/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <cmath>
#include <iostream>

#include "sGFX_colorchooser.hpp"
 
//**************************************************************************

SomaColorChooser::SomaColorChooser(const unsigned int number_in):colors(number_in),
                                                                 number(number_in){
  // fill vector with colors
  /*double bogen = 0;
  const double inc =  2*(3.1415926535897932385)/(number); 
  for(unsigned int i=0;i<number;i++){

    colors[i].x = 0.8*(0.5*cos(bogen)+0.5);
    colors[i].y = 0.8*(0.5*sin(bogen)+0.5); 
    colors[i].z = 0.8*(-0.25*cos(bogen)-0.25*sin(bogen)+0.5);

    bogen += inc;   
  }*/
  
  for(unsigned int i=0;i<number;i++){
    const double rel = double(i) / double(number_in);
    
    if(rel <= 1/6.){
      colors[i].x = rel*6;
      colors[i].y = 0;
      colors[i].z = 1;
    }else if(rel <= 2/6.){
      colors[i].x = 1;
      colors[i].y = 0;
      colors[i].z = 1-(rel-1/6.)*6;
    }else if(rel <= 3/6.){
      colors[i].x = 1;
      colors[i].y = (rel-2/6.)*6;
      colors[i].z = 0;
    }else if(rel <= 4/6.){
      colors[i].x = 1-(rel-3/6.)*6;
      colors[i].y = 1;
      colors[i].z = 0;
    }else if(rel <= 5/6.){
      colors[i].x = 0;
      colors[i].y = 1;
      colors[i].z = (rel-4/6.)*6;
    }else{
      colors[i].x = 0;
      colors[i].y = 1-(rel-5/6.)*6;
      colors[i].z = 1;
    }
    
    colors[i] *= 0.9;
  }
}

//**************************************************************************
  
SomaVector<double> SomaColorChooser::get(const unsigned int color)const{
#ifdef SOMA_DEBUG
  if(color >= number){
    std::cerr << "Color " << color 
              << " out of range in SomaColorChooser::get()." << std::endl;
    return SomaVector<double>(0.5,0.5,0.5);          
  }
#endif

  return colors[color];
}

//**************************************************************************
