/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//**************************************************************************

#ifndef soma_gfx_colorchooser
#define soma_gfx_colorchooser

#include "s_vector.hpp"
#include <vector>

/** This class generates number different colors, represented as vector with a
    red green and blue value each between 0 and 1. */
class SomaColorChooser{
private:
  std::vector<SomaVector<double> > colors;
public:

  /// number of colors in this instance
  const unsigned int number;
  
  /// construtor
  SomaColorChooser(const unsigned int number);
  
  /// get a color for a given index
  SomaVector<double> get(const unsigned int color)const;
  
};

#endif
