/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef soma_gfx_matrix
#define soma_gfx_matrix

//**************************************************************************

class SomaMatrix{
public:
  double mtr[16];
  
  enum AXIS {X=1,Y,Z};
  
  /** create a new identity matrix */
  SomaMatrix();
  
  /** create a new matrix with a another matrix */
  SomaMatrix(const SomaMatrix& other);
  
  /** destructor */
  ~SomaMatrix(){}
  
  /** multiply a new rotation to this matrix */   
  void rotate(const SomaMatrix::AXIS axis,const double deg);
  
  /** reset the matrix to the identity matrix */
  void setIdentity();
};

//**************************************************************************

#endif

