/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef soma_gfx_pieces
#define soma_gfx_pieces

#define HAVE_OPENGL

#include <fx.h>
#include <fx3d.h>

#include <vector>

#include "s_problem.hpp"
#include "sGFX_cubearray.hpp"
#include "sGFX_generic.hpp"

class SomaPiecesGFX : public SomaBaseGFX{
private:
  unsigned int smallwidth,smallheight;
  unsigned int widthdiv,heightdiv;
  unsigned int widthmargin,heightmargin;
  double w,h;

  const SomaProb *const p;
  const unsigned int pieces;
  
  std::vector<SomaCubeArray*> cubes;
  std::vector<SomaMatrix> rotations;
  const SomaVector<double> scolor;
  
  unsigned int selected;
  double distance;
  
  unsigned int is_solved;
  unsigned int active_solution;
  
  void colorCubes();
public:

  // constructor
  SomaPiecesGFX(const SomaProb *const p,const SomaVector<double>& scolor);

  ///destructor
  ~SomaPiecesGFX();
  
  /** notify the object of a mouseclick */
  void mouseClick(const unsigned int x,const unsigned int y,
                  const MOUSEBUTTON button);
 
  /** notify the object of a mousemove */
  void mouseMove(const int deltax,const int deltay,
                 const MOUSEBUTTON button);
                         
  /* notify object that the space for drawing has changed */
  void resize(const unsigned int width,const unsigned int height);
  
  /* draw the object */
  void draw();
};

#endif
